/********************************************************************/
/*                                                                  */
/* Licensed Materials - Property of IBM                             */
/* IBM(R) XL C/C++ Advanced Edition V7.0 for Linux(R)               */
/* 5724-K77                                                         */
/* (C) Copyright IBM Corp. 2003, 2004. All Rights Reserved.         */
/* US Government Users Restricted Rights - Use, duplication or      */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.*/
/*                                                                  */
/********************************************************************/

#ifndef __IBM_VACPP_float_h
#define __IBM_VACPP_float_h 1

#ifndef  __FLT_RADIX__
# define __FLT_RADIX__ 2
#endif

#ifndef  __FLT_MANT_DIG__
# define __FLT_MANT_DIG__ 24
#endif

#ifndef  __FLT_DIG__
# define __FLT_DIG__ 6
#endif

#ifndef  __FLT_EPSILON__
# define __FLT_EPSILON__ 1.19209290e-7F
#endif

#ifndef  __FLT_MIN__
# define __FLT_MIN__ 1.17549435e-38F
#endif

#ifndef  __FLT_MAX__
# define __FLT_MAX__ 3.40282347e+38F
#endif

#ifndef  __FLT_MIN_EXP__
# define __FLT_MIN_EXP__ (-125)
#endif

#ifndef  __FLT_MIN_10_EXP__
# define __FLT_MIN_10_EXP__ (-37)
#endif

#ifndef  __FLT_MAX_EXP__
# define __FLT_MAX_EXP__ 128
#endif

#ifndef  __FLT_MAX_10_EXP__
# define __FLT_MAX_10_EXP__ 38
#endif

#ifndef  __FLT_EVAL_METHOD__
# define __FLT_EVAL_METHOD__ 0
#endif

#ifndef  __FLT_HAS_INFINITY__
# define __FLT_HAS_INFINITY__ 1
#endif

#ifndef  __FLT_HAS_QUIET_NAN__
# define __FLT_HAS_QUIET_NAN__ 1
#endif

#ifndef  __DBL_MANT_DIG__
# define __DBL_MANT_DIG__ 53
#endif

#ifndef  __DBL_DIG__
# define __DBL_DIG__ 15
#endif

#ifndef  __DBL_EPSILON__
# define __DBL_EPSILON__ 2.2204460492503131e-16
#endif

#ifndef  __DBL_HAS_INFINITY__
# define __DBL_HAS_INFINITY__ 1
#endif

#ifndef  __DBL_HAS_QUIET_NAN__
# define __DBL_HAS_QUIET_NAN__ 1
#endif

#ifndef  __DBL_MIN__
# define __DBL_MIN__ 2.2250738585072014e-308
#endif

#ifndef  __DBL_MAX__
# define __DBL_MAX__ 1.7976931348623157e+308
#endif

#ifndef  __DBL_MIN_EXP__
# define __DBL_MIN_EXP__ (-1021)
#endif

#ifndef  __DBL_MIN_10_EXP__
# define __DBL_MIN_10_EXP__ (-307)
#endif

#ifndef  __DBL_MAX_EXP__
# define __DBL_MAX_EXP__ 1024
#endif

#ifndef  __DBL_MAX_10_EXP__
# define __DBL_MAX_10_EXP__ 308
#endif

#ifndef  __LDBL_MANT_DIG__
# ifdef __LONG_DOUBLE_128__
#  define __LDBL_MANT_DIG__ 113
# else
#  define __LDBL_MANT_DIG__ 53
# endif
#endif

#ifndef  __LDBL_DIG__
# ifdef __LONG_DOUBLE_128__
#  define __LDBL_DIG__ 33
# else
#  define __LDBL_DIG__ 15
# endif
#endif

#ifndef  __LDBL_EPSILON__
# ifdef __LONG_DOUBLE_128__
#  define __LDBL_EPSILON__ 1.92592994438723585305597794258492732e-34L
# else
#  define __LDBL_EPSILON__ 2.2204460492503131e-16L
# endif
#endif

#ifndef  __LDBL_HAS_INFINITY__
# define __LDBL_HAS_INFINITY__ 1
#endif

#ifndef  __LDBL_HAS_QUIET_NAN__
# define __LDBL_HAS_QUIET_NAN__ 1
#endif

#ifndef  __LDBL_MIN__
# ifdef __LONG_DOUBLE_128__
#  define __LDBL_MIN__ 3.36210314311209350626267781732175260e-4932L
# else
#  define __LDBL_MIN__ 2.2250738585072014e-308L
# endif
#endif

#ifndef  __LDBL_MAX__
# ifdef __LONG_DOUBLE_128__
#  define __LDBL_MAX__ 1.18973149535723176508575932662800702e+4932L
# else
#  define __LDBL_MAX__ 1.7976931348623157e+308L
# endif
#endif

#ifndef  __LDBL_MIN_EXP__
# ifdef __LONG_DOUBLE_128__
#  define __LDBL_MIN_EXP__ (-16381)
# else
#  define __LDBL_MIN_EXP__ (-1021)
# endif
#endif

#ifndef  __LDBL_MIN_10_EXP__
# ifdef __LONG_DOUBLE_128__
#  define __LDBL_MIN_10_EXP__ (-4931)
# else
#  define __LDBL_MIN_10_EXP__ (-307)
# endif
#endif

#ifndef  __LDBL_MAX_EXP__
# define __LDBL_MAX_EXP__ 1024
#endif

#ifndef  __LDBL_MAX_10_EXP__
# define __LDBL_MAX_10_EXP__ 308
#endif

#ifndef  __DECIMAL_DIG__
# ifdef __LONG_DOUBLE_128__
#  define __DECIMAL_DIG__ 36
# else
#  define __DECIMAL_DIG__ 17
# endif
#endif

#ifdef __cplusplus

# ifndef  __FLT_DENORM_MIN__
#  define __FLT_DENORM_MIN__ 1.40129846e-45F
# endif

# ifndef  __DBL_DENORM_MIN__
#  define __DBL_DENORM_MIN__ 4.9406564584124654e-324
# endif

# ifndef  __LDBL_DENORM_MIN__
#  ifdef __LONG_DOUBLE_128__
#   define __LDBL_DENORM_MIN__ 6.47517511943802511092443895822764655e-4966L
#  else
#   define __LDBL_DENORM_MIN__ 4.9406564584124654e-324L
#  endif
# endif

#endif /* __cplusplus */

#include_next <float.h>

#endif /* not __IBM_VACPP_float_h */ 
