/********************************************************************/
/*                                                                  */
/* Licensed Materials - Property of IBM                             */
/* IBM(R) XL C/C++ Advanced Edition V7.0 for Linux(R)               */
/* 5724-K77                                                         */
/* (C) Copyright IBM Corp. 2003, 2004. All Rights Reserved.         */
/* US Government Users Restricted Rights - Use, duplication or      */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.*/
/*                                                                  */
/********************************************************************/

#ifndef __IBM_VACPP_stdarg_h
#ifndef __need___va_list
#define __IBM_VACPP_stdarg_h 1
#endif /* not __need___va_list */
#undef __need___va_list

#if __cplusplus
extern "C" {
#endif

#undef _Va_start
#undef _Va_arg
#undef _Va_end
#undef __va_copy

#if __64BIT__

# ifndef __BUILTIN_VA_LIST
# define __BUILTIN_VA_LIST
  typedef char *__builtin_va_list;
# endif

# if __cplusplus
#  define _Va_start(__list,__parmN) ( (__list) = __vastart(__parmN) )
# else
#  define _Va_start(__list,__parmN) \
        ( (__list) = (char *)((unsigned long)&(__parmN) + (((sizeof(__parmN)+7)/8)*8)) )
# endif

#  define _Va_align(__list,__t)  __extension__ \
        ( (__list) = (__typeof__(__list)) (((unsigned long)(__list) + \
                      ((__alignof__(__t) == 16 && !__is_longDouble(__t)) ? 15 : 3)) \
                      & ~((__alignof__(__t) == 16 && !__is_longDouble(__t)) ? 15 : 3)) )

# define _Va_arg(__list,__t)  \
         ( (_Va_align(__list,__t), (((__list) += (((sizeof(__t)+7)/8)*8))-sizeof(__t))) )
# define _Va_end(__list)  ( (__list) = (char *)0 )
# define __va_copy(__list1,__list2)  ( (__list1) = (__list2) )

#else /* 32-bit */

  extern void _Builtin __vastart(void *);
  extern void* __va_arg(void*, int);

# define _Va_start(__list,__parmN)  ( __vastart(&(__list)) )
# define _Va_arg(__list,__t) \ 
         ( __va_arg( (__list), __builtin_va_arg_incr((__typeof__(__typeof__(__t) *))0)) )
# define _Va_end(__list)  ( (void*)0 )
# define __va_copy(__list1,__list2)  ( (__list1)[0] = (__list2)[0] )

#endif /* 32-bit */

#ifndef __GNUC_VA_LIST
#define __GNUC_VA_LIST
typedef __builtin_va_list __gnuc_va_list;
#endif

#if !defined(__VA_LIST) && !defined(_VA_LIST_DEFINED) && !defined(_VA_LIST) && !defined(_VA_LIST_T_H) && !defined(__va_list__)
#define __VA_LIST
#define _VA_LIST_DEFINED
#define _VA_LIST
#define _VA_LIST_T_H
#define __va_list__
typedef __builtin_va_list va_list;
#endif

#if __IBM_VACPP_stdarg_h

#define va_start(__list,__parmN)  ( (void) _Va_start(__list,__parmN) )
#if __64BIT__
# define va_arg(__list,__t)  __extension__ \
         ((__typeof__(__typeof__(__t) *)) _Va_arg(__list,__t))[0]
#else
# define va_arg(__list,__t)  __extension__ \
         (*((__typeof__(__typeof__(__t) *)) _Va_arg(__list,__t)))
#endif /* __64BIT__ */
#define va_end(__list) ( (void) _Va_end(__list) )

#if !(__STDC__ && __STDC_VERSION__ < 199901L)
# ifdef va_copy
#  undef va_copy
# endif
# define va_copy(__list1,__list2) ( (void) (__va_copy(__list1,__list2)) )
#endif

#endif /* __IBM_VACPP_stdarg_h */

#if __cplusplus
}
#endif

#endif /* not __IBM_VACPP_stdarg_h */ 
