/********************************************************************/
/* Licensed Materials - Property of IBM                             */
/* IBM(R) XL C/C++ Advanced Edition V7.0 for Linux(R)               */
/* 5724-K77                                                         */
/* (C) Copyright IBM Corp. 2003, 2004. All Rights Reserved.         */
/* US Government Users Restricted Rights - Use, duplication or      */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.*/
/*                                                                  */
/********************************************************************/


#ifndef _BUILTINS_H
#define _BUILTINS_H 1
#if __cplusplus
#include <sys/types.h>
#ifdef __builtinDecl
#undef __builtinDecl
#endif
#define __builtinDecl extern "builtin"

__builtinDecl int __abs(int); 
__builtinDecl void __alignx(int, const void*);
__builtinDecl void* __alloca(size_t); 
__builtinDecl int __assert1(int, int, int);
__builtinDecl void __assert2(int);
__builtinDecl void __bcopy(char *, char *, int);
__builtinDecl unsigned int __check_lock_mp(const int*, int, int);
__builtinDecl unsigned int __check_lock_up(const int*, int, int);
__builtinDecl void __clear_lock_mp(const int*, int);
__builtinDecl void __clear_lock_up(const int*, int);
#ifdef _LONG_LONG
__builtinDecl unsigned int __check_lockd_mp (const long long*, long long, long long);
__builtinDecl unsigned int __check_lockd_up (const long long*, long long, long long);
__builtinDecl void __clear_lockd_mp (const long long*, long long);
__builtinDecl void __clear_lockd_up (const long long*, long long);
#endif
__builtinDecl unsigned int __cntlz4(unsigned int);
__builtinDecl unsigned int __cnttz4(unsigned int);
#ifdef _LONG_LONG
__builtinDecl unsigned int __cntlz8(unsigned long long);
__builtinDecl unsigned int __cnttz8(unsigned long long);
#endif
__builtinDecl void __eieio(void);
__builtinDecl double __fcfid(double);
__builtinDecl double __fctid(double);
__builtinDecl double __fctidz(double);
__builtinDecl double __fctiw(double);
__builtinDecl double __fctiwz(double);
__builtinDecl double __fre(double);
__builtinDecl float __frsqrtes(float);
__builtinDecl void __iospace_eieio(void);
__builtinDecl void __iospace_lwsync(void);
__builtinDecl void __iospace_sync(void);
__builtinDecl void __isync(void);
__builtinDecl long __labs(long);
__builtinDecl long long  __llabs(long long); 
__builtinDecl unsigned int __load4r(unsigned int *);
__builtinDecl unsigned short __load2r(unsigned short *);
__builtinDecl void __lwsync(void);
__builtinDecl void* __memchr(const void *, int , size_t); 
__builtinDecl int   __memcmp(const void *, const void *, size_t); 
__builtinDecl void* __memccpy(void *, const void *, int , size_t);
__builtinDecl void* __memcpy(void *, const void *, size_t);
__builtinDecl void* __memmove(void *, const void *, size_t);
__builtinDecl void* __memset(void *, int , size_t);
__builtinDecl unsigned long __mfdcr(int);
__builtinDecl unsigned long __mfspr(int);
__builtinDecl unsigned long __mfmsr();
__builtinDecl void __mtdcr(int, unsigned long);
__builtinDecl void __mtfsb0(unsigned int);
__builtinDecl void __mtfsb1(unsigned int);
__builtinDecl void __mtfsf(unsigned int, double);
__builtinDecl void __mtfsfi(unsigned int, unsigned int);
__builtinDecl void __mtmsr(unsigned long);
__builtinDecl void __mtspr(int, unsigned long);
#ifdef _LONG_LONG
__builtinDecl long long __mulhd(long long, long long);
__builtinDecl unsigned long long __mulhdu(unsigned long long, unsigned long long);
#endif
__builtinDecl int __mulhw(int, int);
__builtinDecl unsigned int __mulhwu(unsigned int, unsigned int);
__builtinDecl int __parthds(void);
__builtinDecl int __popcnt4(unsigned int);
__builtinDecl int __poppar4(unsigned int);
#ifdef _LONG_LONG
__builtinDecl int __popcnt8(unsigned long long);
__builtinDecl int __poppar8(unsigned long long);
#endif
__builtinDecl unsigned long __popcntb(unsigned long);
__builtinDecl void __prefetch_by_load(const void*);
__builtinDecl void __prefetch_by_stream(const int, const void*);
__builtinDecl void __protected_unlimited_stream_set_go(unsigned int direction, const void* addr, unsigned int ID);
__builtinDecl void __protected_stream_set(unsigned int direction, const void* addr, unsigned int ID);
__builtinDecl void __protected_stream_count(unsigned int unit_cnt, unsigned int ID);
__builtinDecl void __protected_stream_go();
__builtinDecl void __protected_stream_stop(unsigned int ID);
__builtinDecl void __protected_stream_stop_all();

#ifdef _LONG_LONG
__builtinDecl unsigned long long __rdlam(unsigned long long, unsigned int, unsigned long long);
__builtinDecl unsigned long long __rldimi(unsigned long long, unsigned long long, unsigned int, unsigned long long);
__builtinDecl unsigned long long __rotatel8(unsigned long long, unsigned long long);
#endif
__builtinDecl double __readflm(void);
__builtinDecl unsigned int __rlwimi(unsigned int, unsigned int, unsigned int, unsigned int);
__builtinDecl unsigned int __rlwnm(unsigned int, unsigned int, unsigned int);
__builtinDecl unsigned int __rotatel4(unsigned int, unsigned int);
__builtinDecl double __setflm(double);
__builtinDecl double __setrnd(int);
__builtinDecl void __stfiw(const int*, double);
__builtinDecl void __store2r(unsigned short, unsigned short *);
__builtinDecl void __store4r(unsigned int, unsigned int *);
__builtinDecl char* __strcat(char *, const char *);
__builtinDecl char* __strchr(const char *, int);
__builtinDecl int   __strcmp(const char *, const char *);
__builtinDecl char* __strcpy(char *, const char *);
__builtinDecl size_t __strlen(const char *);
__builtinDecl char* __strncat(char *, const char *, size_t);
__builtinDecl int   __strncmp(const char *, const char *, size_t);
__builtinDecl char* __strncpy(char *, const char *, size_t);
__builtinDecl char* __strrchr(const char *, int);
__builtinDecl double __swdiv(double, double);
__builtinDecl double __swdiv_nochk(double, double);
__builtinDecl float __swdivs(float, float);
__builtinDecl float __swdivs_nochk(float, float);
__builtinDecl void __sync(void);
#ifdef _LONG_LONG
__builtinDecl void __tdw(long long, long long, unsigned int);
#endif
__builtinDecl void __tw(int, int, unsigned int);
__builtinDecl void __umul_dbl(unsigned long,unsigned long,unsigned long *);
__builtinDecl int __usrthds(void);

/* 
 * __fmadd (a, x, y) = [a * x + y] 
 */
__builtinDecl float __fmadds (float, float, float); 
__builtinDecl double __fmadd (double, double, double); 

/* 
 * __fmsub (a, x, y) = [a * x - y] 
 */
__builtinDecl float __fmsubs (float, float, float);
__builtinDecl double __fmsub (double, double, double);

/* 
 * __fnmadd (a, x, y) = [- (a * x + y)] 
 */
__builtinDecl float __fnmadds (float, float, float);
__builtinDecl double __fnmadd (double, double, double);

/* 
 * __fnmsub (a, x, y) = [- (a * x - y)] 
 */
__builtinDecl float __fnmsubs (float, float, float);
__builtinDecl double __fnmsub (double, double, double);

/* 
 * __fsqrt (x) = square root of x
 */
__builtinDecl float __fsqrts (float);
__builtinDecl double __fsqrt (double);

/* 
 * __frsqrte (x) = [(estimate of) 1.0/sqrt(x)] 
 */
__builtinDecl double __frsqrte (double);

/* 
 * __fres (x) = [(estimate of) 1.0/x]
 */
__builtinDecl float __fres (float);

/* 
 * if (a >= 0.0) then 
 *    __fsel (a, x, y) = x; 
 * else 
 *    __fsel (a, x, y) = y 
 */
__builtinDecl float __fsels (float, float, float);
__builtinDecl double __fsel (double, double, double);

/* 
 * __fabs (x) = |x|
 */
__builtinDecl float __fabss (float);

/* 
 * __fnabs (x) = -|x|
 */
__builtinDecl float __fnabss (float);
__builtinDecl double __fnabs (double);

/* 
 * Data Cache Block Touch. Loads the block of memory containing the 
 * specified address into the data cache.
 */
__builtinDecl void __dcbt (void *);

/* 
 * Data Cache Block set to Zero. Sets the specified address in the data 
 * cache to zero (0).
 */
__builtinDecl void __dcbz (void *);

/* 
 * Trap if the parameter is not zero
 */
__builtinDecl void __trap (int);
#if _LONG_LONG
__builtinDecl void __trapd (long long);
#endif

#endif
#undef __builtinDecl
#endif
